//+------------------------------------------------------------------+
//|                                                       Rj_RMA.mq5 |
//|                            Copyright  2011,RJ Rjabkov Alexander |
//|                                                     rj-a@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011,RJ Rjabkov Alexander"
#property link      "rj-a@mail.ru"
//---   
#property version   "1.00"
//---     
#property indicator_chart_window 
//---   
#property indicator_buffers 2 
//---     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---      
#property indicator_type1   DRAW_COLOR_LINE
//---      
#property indicator_color1  clrDodgerBlue,clrMagenta
//---   -  
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "Rj_RMA"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint CalcPeriodRange=13;   //  
input int Shift=0;               //      
input int PriceShift=0;          //      
//+-----------------------------------+
//---   ,  
//---       
double IndBuffer[];
double ColorIndBuffer[];
//---      
double dPriceShift;
//---      
int min_rates_total;
//+------------------------------------------------------------------+   
//| X2MA indicator initialization function                           | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   min_rates_total=int(CalcPeriodRange+1);
//---    
   dPriceShift=_Point*PriceShift;
//---      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//---    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//---       
   ArraySetAsSeries(IndBuffer,true);
//---     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,62);
//---      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
//---       
   ArraySetAsSeries(ColorIndBuffer,true);
//---      
   string shortname;
   StringConcatenate(shortname,"Rj_RMA(",CalcPeriodRange,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
  }
//+------------------------------------------------------------------+ 
//| X2MA iteration function                                          | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---       
   double b1,b2;
//---   
   int limit;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates_total-1;  //      
   else limit=rates_total-prev_calculated;  //       
//---         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
//---    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      b1=0.0;
      b2=0.0;
      for(int iii=0; iii<int(CalcPeriodRange); iii++)
        {
         b1+=high[ArrayMaximum(high,bar+iii,CalcPeriodRange)];
         b2+=low[ArrayMinimum(low,bar+iii,CalcPeriodRange)];
        }
      IndBuffer[bar]=NormalizeDouble((b1+b2)/(CalcPeriodRange*2.0),_Digits);
     }
//---    limit
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      limit--;
//---     
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      ColorIndBuffer[bar]=0;
      if(IndBuffer[bar-1]<IndBuffer[bar]) ColorIndBuffer[bar]=1;
      if(IndBuffer[bar-1]>IndBuffer[bar]) ColorIndBuffer[bar]=2;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
